**************************************************************************
* This macro file is useful for Pascal programming. It allows you to     *
* insert all important program-structures with one key.                  *
* written           : 06.02.86 Matthias Aebi                             *
* Last modification : 31.03.86 Matthias Aebi                             *
**************************************************************************

* 1
* puts braces around the current selection
"Comment/K" {
    Push;
    Select(L],C]);
    Insert(" }");
    Select(L[,C[);
    Insert("{ ");
    Pop;
    If L. = L: {
        Select(L.,C. | L:,C:+4);
    }
    Else {
        Select(L.,C. | L:,C:+2);
    };
};

* 2
* removes comment-braces at start and end of the current selection
"Uncomment/U" {
    Push;
    Select(L],C]-2 | L],C]);
    Clear;
    Select(L[,C[ | L[,C[+2);
    Clear;
    Pop;
};

* 3
* insert a line in the menu
"-" {};

* 4
* jumps to the next placeholder in a Pascal structure
"Placeholder/-" {
    Find("{.");
    If L: = 0 And C: = 0 {
        Find("{.");
    };
    Push;
    Find(".}");
    Select(L[,C[ | L:,C:)!;
    Drop;
};

* 5
* insert a line in the menu
"-" {};

* 6
* insert a PROGRAM template
"PROGRAM/P" {
    Push;
    Insert("PROGRAM {.ProgName.};\N");
    Insert("CONST\n\t{.Constants.};\N\N");
    Insert("TYPE\n\t{.Types.};\N\N");
    Insert("VAR\n\t{.Variables.};\N\N");
    Insert("BEGIN\n\t{.Statement.};\NEND.");

    Call(13);
};

* 7
* insert a PROCEDURE template
"PROCEDURE" {
    Push;
    Insert("PROCEDURE {.ProcName.} ({.Parameters.});\n");
    Insert("CONST\n\t{.Constants.};\n\T\n");
    Insert("TYPE\n\t{.Types.};\n\T\n");
    Insert("VAR\n\t{.Variables.};\n\T\n");
    Insert("BEGIN\n\t{.Statement.};\n\TEND;");

    Call(13);
};

*8
* insert a BEGIN-END template
"BEGIN/B" {
    Push;
    Insert("BEGIN\n\t{.Statement.};\n\TEND;");

    Call(12);
    Call(13);
};

* 9
* insert a FOR-TO-DO template
"FOR/L" {
    Push;
    Insert("FOR {.Variable.} := {.Value.} TO {.Value.} DO\n");
    Insert("\t{.Statement.};");

    Call(12);
    Call(13);
};

* 10
* insert a CASE template
"CASE" {
    Push;
    Insert("CASE {.Value.} OF\n{.Constant.}:\n\t");
    Insert("{.Statement.};\n\T\nOTHERWISE\n\t");
    Insert("{.Statement.};\n\T\nEND;");

    Call(12);
    Call(13);
};

* 11
* insert an IF-THEN-ELSE template
"IF/I" {
    Push;
    Insert("IF {.Condition.}\nTHEN\n\t{.Statement.}\n\T");
    Insert("ELSE\n\t{.Statement.};");

    Call(12);
    Call(13);
};

* 12
* change ;; to ; if any
{
    Push;
    Select(L.,C.-1);
    Find(";;");
    If L. = L[ {
        Insert(";");
    };
    Pop;
};

* 13
* select first placeholder
{
    Pop;
    Find("{.");
    Push;
    Find(".}");
    Select(L[,C[ | L:,C:)!;
    Drop;
}.
