/* doflips.c - DoFlips */

#include "mac/quickdraw.h"
#include "mac/osintf.h"
#include "mac/toolintf.h"
#include "othello.h"



DoFlips(color, move, board, flips, visible)
int	color;
MoveRecord	move;
BoardArray	board;
MoveList	flips;
int		visible;
{
	register int	drow, dcol;
	register int	frow, fcol, nFlips;
	int		ticks;

	ticks = TickCount();
	nFlips = 0;
	for (drow = -1; drow <= 1; ++drow)
	    for (dcol = -1; dcol <= 1; ++dcol) {
		for (frow = move.row + drow, fcol = move.col + dcol;
			(board[frow][fcol] & stoneColor) ==
				opposite(color);
			frow += drow, fcol += dcol)
			;
		if ((board[frow][fcol] & stoneColor) != color)
			continue;
		for (frow -= drow, fcol -= dcol;
				!(frow == move.row && fcol == move.col);
				frow -= drow, fcol -= dcol) {
			flips[nFlips].row = frow;
			flips[nFlips].col = fcol;
			if (visible || trace > 1)
				PlaceStone(frow, fcol, color);
			else
				board[frow][fcol] = color;
			board[frow][fcol] |= flipped;
			++nFlips;
		}
	    }
	nTicks[pDoFlips] += TickCount() - ticks;
	return(nFlips);
}
