/* domove.c - DoMove */

#include "mac/quickdraw.h"
#include "mac/osintf.h"
#include "mac/toolintf.h"
#include "othello.h"



DoMove(move)
MoveRecord	move;
{
	MoveList moves;
	int	inrow, incol;

	ClearMessages();
	if (player[curColor] == Macintosh) {
		strcpy(message, "Thinking...");
		UpdateInfo();
		ChooseMove(&move, GameBoard);
		strcpy(message, "");
	}
	if (StopThinking)
		return;
	if (GameBoard[move.row][move.col] & stoneColor) {
		strcpy(message, "Illegal move (space is occupied)");
		return;
	}
	PlaceStone(move.row, move.col, curColor);
	if (DoFlips(curColor, move, GameBoard, moves, VISIBLE) == 0) {
		strcpy(message, "Illegal move (no flips)");
		PlaceStone(move.row, move.col, stoneEmpty);
		return;
	}

	/* Otherwise, a legal move; if it was a corner, adjust weights */
	inrow = incol = 0;
	switch (move.row) {
	case 1:		inrow = 2;
			break;
	case BOARDSIZE:	inrow = BOARDSIZE - 1;
			break;
	}
	switch (move.col) {
	case 1:		incol = 2;
			break;
	case BOARDSIZE:	incol = BOARDSIZE - 1;
			break;
	}
	if (inrow && incol)
		position[inrow][incol] = 0;

	/* Find out who moves next. */
	if (FindMoves(opposite(curColor), GameBoard, moves, ALL) > 0)
		curColor = opposite(curColor);
	else if (FindMoves(curColor, GameBoard, moves, ALL) > 0)
		sprintf(message, "%s cannot move.",
			colorName[opposite(curColor)]);
	else {
		GameOver = TRUE;
		if (nStones[stoneWhite] == nStones[stoneBlack])
			strcpy(message, "A tie!");
		else
			sprintf(message, "%s wins.",
				(nStones[stoneWhite] > nStones[stoneBlack])?
					"White" : "Black");
	}
}
