/* drawboard.c - DrawBoard */

# include	"mac/quickdraw.h"
# include	"mac/osintf.h"
# include	"mac/toolintf.h"
# include	"othello.h"

/*
 * DrawBoard:
 *	Draw the playing board.
 */

DrawBoard()
{
	int	row, col;
	Rect	dot;
	
	PenSize(1, 1);
	/* Draw the board */
	for (row = 0; row <= BOARDSIZE; ++row) {
		MoveTo(SCALE*row + SCALE/2, SCALE/2);
		LineTo(SCALE*row + SCALE/2, BOARDSIZE*SCALE + SCALE/2);
		MoveTo(SCALE/2			, SCALE*row + SCALE/2);
		LineTo(BOARDSIZE*SCALE + SCALE/2, SCALE*row + SCALE/2);
	}

	/* Draw the dots at the corners of the center region */
	for (row = 2; row < BOARDSIZE; row += 4)
		for (col = 2; col < BOARDSIZE; col += 4) {
			dot.top = dot.bottom = SCALE*row + SCALE/2;
			dot.left = dot.right = SCALE*col + SCALE/2;
			dot.top -= 3;
			dot.left -= 3;
			dot.bottom += 4;
			dot.right += 4;
			PaintOval(&dot);
		}

	/* Draw the stones in their current positions */
	for (row = 1; row <= BOARDSIZE; ++row)
	    for (col = 1; col <= BOARDSIZE; ++col) {
		dot.top		= SCALE*(row) - SCALE/2 + 1;
		dot.left	= SCALE*(col) - SCALE/2 + 1;
		dot.bottom	= SCALE*(row) + SCALE/2;
		dot.right	= SCALE*(col) + SCALE/2;
		switch (GameBoard[row][col] & stoneColor) {
		case stoneWhite:
			FrameOval(&dot);
			break;
		case stoneBlack:
			PaintOval(&dot);
			break;
		}
	    }
}
