/* findmoves.c - FindMoves */

#include "mac/quickdraw.h"
#include "mac/osintf.h"
#include "mac/toolintf.h"
#include "othello.h"

#define diagonal(row, col)	((row) == (col) || BOARDSIZE+1-(row) == (col))



int FindMoves(color, board, moves, all)
int		color;
BoardArray	board;
MoveList	moves;
int		all;
{
	int		nMoves = 0;
#ifdef UNDEF
	int		ToBeTried;
#endif
	int		row, col;
	register char	*square, *msquare;
	register int	direction;
	register int	opponent = opposite(color);
	int		dcol, drow;
	int		ticks;
	
	ticks = TickCount();
	for (row = 1; row <= BOARDSIZE; ++row)
	    for (col = 1; col <= BOARDSIZE; ++col) {
		square = &board[row][col];
		if ((*square & stoneColor) != stoneEmpty)
			continue;
		for (drow = -1; drow <= 1; ++drow)
		    for (dcol = -1; dcol <= 1; ++dcol) {
#ifdef UNDEF
			ToBeTried = (all || diagonal(row, col) ||
				(*square & threat));
#endif
			msquare = &board[row+drow][col+dcol];
			if ((*msquare & stoneColor) != opponent)
				continue;
			direction = msquare - square;
			do {
#ifdef UNDEF
				ToBeTried = (ToBeTried ||
					diagonal(mrow, mcol) ||
					(*msquare & flipped));
#endif
				msquare += direction;
			} while ((*msquare & stoneColor) == opponent);
			if (
#ifdef UNDEF
			ToBeTried &&
#endif
			(*msquare & stoneColor) == color) {
				moves[nMoves].row = row;
				moves[nMoves].col = col;
				++nMoves;
				goto NextSquare;
			}
		    }
NextSquare: ;
	    }
	nTicks[pFindMoves] += TickCount() - ticks;
	return(nMoves);
}
