/* othello.h - opposite, GameBoard */

char *sprintf(), *strcpy();

#define TRUE		1
#define FALSE		0
#define NIL		((Handle) 0)
#define bool		char
#define BUFSIZ		80
#define NULL		0
#define ERROR		-1
#define VISIBLE		TRUE
#define INVISIBLE	FALSE
#define ALL		TRUE
#define RESTRICT	FALSE
#define toupper(c)	(((c) < 'a' || (c) > 'z')? (c) : (c) + 'A' - 'a')
extern WindowPtr	myWindow;

#define FILE	int
#define LINEHEIGHT	16
#define ChicagoFont	0
#define NewYorkFont	2
#define GenevaFont	3
#define MonacoFont	4
#define InfoFont	NewYorkFont
#define InfoSize	12

/* max size of stack; the heap gets the rest */
#define MAXSTACKSIZE	16384			/* default is 8192	*/
#define MaxLookAhead	(MAXSTACKSIZE / 1024)	/* as near as I can tell*/

extern char message[];
extern char note1[], note2[], note3[];
extern int trace;

#define SCALE		24
#define BOARDSIZE	8
#define EndGame		(skill*3/2 + 2)
extern int	GameOver;
extern int	StopThinking;

#define stoneWhite	001
#define stoneBlack	002
#define stoneEmpty	000
#define stoneEdge	003
#define stoneColor	003
#define opposite(c)	(~c & stoneColor)
#define flipped		004		/* stone was just flipped	*/
#define threat		010		/* opponent's best move		*/

extern int curColor;
extern char *colorName[];

#define Macintosh	0
#define Person		1

extern int player[];
extern char *playerName[];
extern int nStones[];
extern int skill;

typedef char BoardArray[BOARDSIZE+2][BOARDSIZE+2];
extern BoardArray	GameBoard;

typedef struct move {
	char	row, col;
	short	value;
} MoveRecord, MoveList[BOARDSIZE*BOARDSIZE];
#define minValue	(-100 * BOARDSIZE * BOARDSIZE)

extern short position[BOARDSIZE+2][BOARDSIZE+2];

#define pRestoreBoard	0
#define pFindMoves	1
#define pDoFlips	2
#define pAnalyze	3
#define pSortMoves	4
#define nTimed		5
extern int nTicks[];	/* amount of time spent in each function	*/
