UNIT ZOOM;

INTERFACE

USES MacIntf;

procedure ZoomRect(VAR smallRect,bigRect: Rect; zoomUp: BOOLEAN);

IMPLEMENTATION

procedure ZoomRect;

const zoomSteps = 16;

var
	rect1,rect2,
	rect3,rect4	: Rect;
	i,j				: INTEGER;
	savePort,
  	thisPort		: GrafPtr;
	fract,factor,
  	one				: Fixed;
    
	function Blend(smallCoord,bigCoord: INTEGER): INTEGER;
	var smallFix,bigFix,tempFix: Fixed;
	begin
		smallFix:=one * smallCoord;
		bigFix  :=one * bigCoord;
		tempFix :=FixMul(fract,bigFix) + FixMul(one-fract,smallFix);
		Blend   :=FixRound(tempFix);
	end;

begin
  GetPort(savePort);
  thisPort := GrafPtr(NewPtr(SizeOf(GrafPort)));
  OpenPort(thisPort);
  InitPort(thisPort);
  SetPort(thisPort);
  PenPat(gray);
  PenMode(notPatXor);

  one:=65536;
  IF zoomUp
  then
    begin
      rect1:=smallRect;
      factor:=FixRatio(6,5);
      fract:=FixRatio(541,10000);
    end
  else
    begin
      rect1:=bigRect;
      factor:=FixRatio(5,6);
      fract:=one;
    end;

  rect2:=rect1;
  rect3:=rect1;
  FrameRect(rect1);

  for i:=1 to zoomSteps do
    begin
      rect4.left   :=Blend(smallRect.left,bigRect.left);
      rect4.right  :=Blend(smallRect.right,bigRect.right);
      rect4.top    :=Blend(smallRect.top,bigRect.top);
      rect4.bottom :=Blend(smallRect.bottom,bigRect.bottom);

      FrameRect(rect4);
      FrameRect(rect1);
      rect1:=rect2;
      rect2:=rect3;
      rect3:=rect4;

      fract:=FixMul(fract,factor);
    end;
  FrameRect(rect1);
  FrameRect(rect2);
  FrameRect(rect3);
  PenNormal;
  ClosePort(thisPort);
  SetPort(savePort);
end;

end.
