/*  			HFS EXAMPLE
	Modified by John Pence, MacMan, Inc., Houston Texas.
		  from MacTutor, Jan,86 issue
             "Programming for HFS" by Miki Schuster.
			   
		A "must have" for the serious programmer
	 	MACTUTOR P.O BOX 400
		PLACENTIA, CA 92670
		(714) 630-3730
		
*/		
#include "stdio.h"
#include "hfs.h"
#include "pbhdefs.h"



/*extern String ptocstr();   Consulair syntax */

extern char *PtoCstr(); /* Lightspeed syntax */
extern int  strlen();
extern char *strncat();

extern char *strntac(); /* from the MMSTR project */
extern char *strtac();  /* from the MMSTR project */

extern OSErr pbCall();  /* its in the pbcall.lib */

/*

these were in the article but removed since they're in pbhdefs.h

#define PBCloseWD(pb, a)	pbCall(pb, a, 0xA260, 2)
#define PBOpenWD(pb, a)		pbCall(pb, a, 0xA260, 1)
#define PBGetWDInfo(pb, a)	pbCall(pb, a, 0xA260, 7)

#define PBHGetVInfo(pb, a)	pbCall(pb, a, 0xA207 )
#define PBGetCatInfo(pb, a)	pbCall(pb, a, 0xA260, 9)
#define PBGetFInfo(pb, a)	pbCall(pb, a, 0xA00C )
*/

void fileproc();

main()
{
	enumerate(&fileproc);
}

enumerate(fileproc)
	int (*fileproc)();
	{
	HVolumeParam vp;
	DirInfoParam dp;
	WDParam wp;
	Str255 vname;
	Str255 dname;
	int32 **dirs;
	int32 *dirp;
	int32 dir;
	int ok;
	
	/* initialize params */
	vp.ioNamePtr = &vname;
	dp.ioNamePtr = &dname;
	wp.ioNamePtr = NULL;
	wp.ioWDProcID = 'ENUM';
	
	/* enumerate each volume */
	for (vp.ioVolIndex = 1; !PBHGetVInfo(&vp, 0); vp.ioVolIndex++)
		{
		dp.ioVRefNum = vp.ioVRefNum;
		
		/* if MFS volume, enumerate each file */
		if (FCBLen == -1 || vp.ioVSigWord == mfsSigWord)
			for (dp.ioFDirIndex = 1; !PBGetFInfo(&dp, 0); dp.ioFDirIndex++)
				(*fileproc)(dp.ioVRefNum, &vp, &dp);
			
		/* if HFS volume, allocate space for directory queue */
		else if (dirs = (int32 **) NewHandle(vp.ioVDirCnt * sizeof(int32)))
			{
			/* place root into directory queue */
			HLock(dirs);
			dirp = *dirs;
			*dirp++ = rootDirID;
			
			/* enumerate directory queue */
			while (dirp > *dirs)
				{
				dir = *--dirp;
				wp.ioVRefNum = dp.ioVRefNum;
				wp.ioWDDirID = dir;
				
				/* open working directory */
				if (!PBOpenWD(&wp, 0))
					{
					/* enumerate files in directory */
					for (dp.ioFDirIndex = 1, dp.ioDrDirID = dir; !PBGetCatInfo(&dp, 0); dp.ioFDirIndex++, dp.ioDrDirID = dir)
						{
						/* if offspring is a directory, place on queue */
						if (dp.ioFlAttrib & ioDirFlg)
							*dirp++ = dp.ioDrDirID;
						
						/* if offsprint is a file, call argument function */
						else
							(*fileproc)(wp.ioVRefNum, &vp, &dp);
						}
					
					/* all done with working directory */
					PBCloseWD(&wp, 0);
					}
				}
			DisposHandle(dirs);
			}
		}
	}

char *pathname(pname, wdrefnum, n)
	char *pname;
	int16 wdrefnum;
	int16 n;
	{
	HVolumeParam vp;
	WDParam wp;
	DirInfoParam dp;
	Str255 dname;
	
	/* initialize params */
	pname[0] = '\0';
	n--;
	vp.ioNamePtr = &dname;
	vp.ioVRefNum = wdrefnum;
	vp.ioVolIndex = 0;
	wp.ioNamePtr = NULL;
	wp.ioVRefNum = wdrefnum;
	wp.ioWDIndex = 0;
	wp.ioWDProcID = NULL;
	dp.ioNamePtr = &dname;
	dp.ioFDirIndex = -1;
	
	/* get volume information */
	if (!PBHGetVInfo(&vp, 0))
		/* if MFS or HFS root, return volume name */
		if (FCBLen == -1 || vp.ioVSigWord == mfsSigWord || vp.ioVRefNum == wdrefnum)
			strncat(pname, PtoCstr(vp.ioNamePtr), n - 1);
		
		/* get working directory information */
		else if (!PBGetWDInfo(&wp, 0))
			{
			/* traverse path from working directory to root */
			dp.ioVRefNum = wp.ioWDVRefNum;
			dp.ioDrParID = wp.ioWDDirID;
			do
				{
				/* get next node information */
				dp.ioDrDirID = dp.ioDrParID;
				if (PBGetCatInfo(&dp, 0))
					break;
				
				/* concatenate node name to result */
				strntac(strtac(pname, ":"), PtoCstr(dp.ioNamePtr), n - 1);
				n -= strlen(dp.ioNamePtr) + 1;
				}
			while (dp.ioDrDirID != rootDirID);
			
			/* remove last colon */
			pname[strlen(pname) - 1] = '\0';
			}
	return pname;
	}

void fileproc(wdrefnum, vp, fp)
	int16 wdrefnum;
	HVolumeParam *vp;
	DirInfoParam *fp;
	{
	char name[256];
	
	
	pathname(name, wdrefnum, sizeof name);
	PtoCstr(fp->ioNamePtr);
	printf("%s:%s\n", name, fp->ioNamePtr);
	CtoPstr(fp->ioNamePtr);
	}


